

%****Reference*******
% Guohua Wu, Across neighbourhood search for numerical optimization. Information Sciences, 329 (2016): 597-618.

clear all;
clc
format shortG
format compact
strParameterDescription = 'ps=20; D=30;'
arrayNLforD30 = [28,1,10,28,1,28,1,1,28,1,1,1,28,28,28,1,28,28];
arrayNLforD100 = [8,20,8,10,10,10,1,1,10,1,1,1,10,10,8, 1,20,40];

arrayNEFs = [150000  150000  150000  150000  150000  150000  250000  150000 150000  150000  150000  150000]; % for comparing with some new emergering PBSAs
global M
Mstruct = load('Common_M_100');
M = Mstruct.M;

ps=20;
D=30;
alpha = 0.5;
fhd=str2func('benchmark_func');
VRminXX = [-500, -2.048, -10,-10, -100, -2.048, -5.12, -600, -32,  -600, -50, -50, -500, -2.048, -10, -5.12, -32, -600, -5, -5, -5,0,0,0];
VRmaxXX=-VRminXX;
VRmax(21:24) = [15,1,1,10];
rand('state',sum(100*clock));
NEF = 0;
fistJudge = 1;
%%%%%%%%%%%
for fun= 1:18
   MaxFES=300000;  %or 600000, arrayNEFs(fun);
   MaxGen=MaxFES/ps;
    for run=1:1
        numberOfLearn = arrayNLforD30(fun); % arrayNLforD100(fun)
        VRmin=repmat(VRminXX(fun),ps,D);
        VRmax=repmat(VRmaxXX(fun),ps,D);
        pos=VRmin+(VRmax-VRmin).*rand(ps,D);
        origPos = pos;
        for i=1:ps;
            val(i,1)=feval(fhd,pos(i,:),fun);
        end
        origVal = val;
        fitcount=ps;
        pbest=pos;
        origPbest = pbest;
        pbestval=val; %initialize the pbest and the pbest's fitness value
        origPbestval = val;
        [gbestval,gbestid]=min(pbestval);
        gbest=pbest(gbestid,:);%initialize the gbest and the gbest's fitness value
        indexExamp = ones(ps,D);
        i=1;
        fistJudge = 1;
        while i<=MaxGen && fitcount<=MaxFES
            zzz(i) = gbestval;
             [fun, i, gbestval]
            i=i+1;
            for k=1:ps
                array = [1:k-1,k+1:ps];
                indexExamp(k,:) =k.*ones(1,D);
                rp2 = randi([1,ps-1],1,D);
                fi2=array(rp2);
                fi = fi2;  % please note here whether to remove off
                indexVector = randi([1 D],1,numberOfLearn);
                for dd=1:numberOfLearn
                    indexExamp(k,indexVector(dd))= fi(indexVector(dd));
                end
                for dimcnt=1:D
                    valExamp(k,dimcnt)=pbest(indexExamp(k,dimcnt),dimcnt);
                end
                amplify = abs(valExamp(k,:)-pos(k,:));
                pos(k,:)= valExamp(k,:) + random('Normal',0,alpha,1,D).*amplify;
                sumBound = (sum(pos(k,:)>VRmax(k,:))+sum(pos(k,:)<VRmin(k,:))); % judge whether the position is among the bounds
                pos(k,:)=(pos(k,:)>VRmax(k,:)).*(VRmin(k,:)+(VRmax(k,:)-VRmin(k,:)).*rand(1,D))+(pos(k,:)<=VRmax(k,:)).*pos(k,:);% move into the bound
                pos(k,:)=(pos(k,:)<VRmin(k,:)).*(VRmin(k,:)+(VRmax(k,:)-VRmin(k,:)).*rand(1,D))+(pos(k,:)>=VRmin(k,:)).*pos(k,:);% move into the bound
                
                val(k) = feval(fhd,pos(k,:),fun);
                fitcount=fitcount+1;
                if val(k)<pbestval(k) % updata pbest
                    pbest(k,:) = pos(k,:);
                    pbestval(k) = val(k);
                end
                if pbestval(k)<gbestval %update the the elist, best found so far
                    gbest=pbest(k,:);
                    gbestval=pbestval(k);
                end
            end
            if gbestval < 1e-5 && fistJudge == 1
                fistJudge = 0;
                NEF =  fitcount;
            end
        end
        NEFSet (fun,run) = NEF;
        gbestValSet(fun,run) = gbestval;
        fun
        run
        gbestval
    end
end




